<template>
  <div id="app">
    <button
      class="actualizacion primary"
      v-if="actualizacionDisponible"
      @click="actualizar"
    >
      hay una actualización disponible! clik aki!
    </button>
    <Nav v-if="!$route.meta.fullScreen" />
    <div class="view-container" v-if="initialLoadDone">
      <router-view />
    </div>
    <footer>
      <p>Copyleft <CopyleftIcon /> Partido Interdimensional Pirata</p>
    </footer>
  </div>
</template>

<script>
import { mapState } from 'vuex'

import Nav from '@/components/Nav'
import CopyleftIcon from '@/components/CopyleftIcon'

export default {
  name: 'App',
  components: { Nav, CopyleftIcon },
  computed: mapState(['initialLoadDone', 'actualizacionDisponible']),
  methods: {
    actualizar() {
      window.__registration.waiting.postMessage('skipWaiting')
    },
  },
}
</script>

<style lang="sass">
html
  --background: #181818
  --foreground: #d8d8d8
  --accent: #ba8baf
  --gray: #c7c7c7
  --darkgray: #8f8f8f
  --verydarkgray: #b8b8b8
  --blackish: #121212
  --darkred: #C62828
  --red: #ab4642

  color: var(--foreground)
  background: var(--background)
  word-wrap: break-word
  box-sizing: border-box
  overflow-x: hidden
  overflow-y: scroll

  font-size: 20px

body
  margin: 0

*, *::before, *::after
  box-sizing: inherit

#app
  //font-family: 'Source Code Pro', monospace
  font-family: 'IBM Plex Mono', 'Menlo', 'DejaVu Sans Mono', 'Bitstream Vera Sans Mono', Courier, monospace
  -webkit-font-smoothing: antialiased
  -moz-osx-font-smoothing: grayscale
  //text-align: center

  max-width: 700px
  margin: 0 auto

@import './ibm-plex-mono.css'

//@font-face
//    font-family: 'Source Code Pro'
//    font-weight: 400
//    font-style: normal
//    font-stretch: normal
//    src: url('~source-code-pro/WOFF2/TTF/SourceCodePro-Regular.ttf.woff2') format('woff2')

.view-container
  max-width: 700px
  //margin: 15px auto

button
  appearance: none
  background: var(--background)
  color: var(--foreground)

  border: 5px solid var(--accent)
  border-radius: 10px

  font-size: 1.2em
  font-family: inherit

  padding: 8px 12px
  margin: 10px
  display: inline-flex
  user-select: none
  justify-content: center
  align-items: center

  &.primary
    --foreground: var(--background)
    background: var(--accent)
  &.red
    --accent: var(--darkred)
  &.small
    font-size: 0.7em
    padding: 6px 8px
    margin: 0
  &.circle
    font-size: 2em
    width: 48px
    height: 48px
    padding: 6px
    &.loading
      svg
        animation: spinAround 0.5s infinite linear

.loading-anim
  animation: spinAround 0.5s infinite linear

input, textarea, select
  border: solid 2px var(--foreground)
  transition: border-color 0.3s
  border-radius: 10px

  padding: 0.5em 0.6em
  margin: 0.5em 0.4em
  resize: none

  background: transparent
  color: var(--foreground)

  font-family: inherit
  font-size: 1em
  &:focus, &:hover
    border-color: var(--accent)

textarea
  height: 10em

form
  display: flex
  flex-direction: column

footer
  text-align: center
  margin: 0 0.5em
  font-size: 0.8em
a
  color: var(--accent)

.error
  color: var(--red)
  padding: .5em
  font-weight: bold
  a
    color: var(--background)

.input-error
  color: var(--red)
  font-size: .8em

.container
  padding: 0 20px

.inline-nav
  display: flex
  a
    display: block
    padding: 0 15px
    border-right: 3px solid var(--accent)
    text-decoration: none
    color: var(--darkgray)
    &.active
      color: var(--foreground)
    &:last-of-type
      border-right: none

header
  display: flex
  flex-wrap: wrap
  align-items: center
  margin: 0
  h1, h2, h3, h4, h5, h6
    padding: .25em 0
    margin: 0
  .buttons
    display: flex
    justify-content: flex-end
    flex: 1

.actualizacion
  position: sticky
  top: 0

button svg
  width: 100%
  //height: 100%

@keyframes spinAround
  from
    transform: rotate(0)
  to
    transform: rotate(359deg)

//@font-face
//  font-family: 'Fira Mono'
//  src: url('./assets/fonts/FiraMono-Regular.woff2') format('woff2')
//  font-weight: 400
//  font-style: normal
</style>
